import 'package:analyzer/dart/element/element.dart';
import 'package:build/src/builder/build_step.dart';
import 'package:custom_package/src/annotations/hitung_bujur_sangkar.dart';
import 'package:custom_package/src/builders/model_visitor.dart';
import 'package:source_gen/source_gen.dart';


class BujurSangkarGenerator extends GeneratorForAnnotation<HitunBujurSangkar> {
  @override
  generateForAnnotatedElement(
      Element element, ConstantReader annotation, BuildStep buildStep) {
    // TODO: implement generateForAnnotatedElement

    return _generateSource(element);
  }

  String _generateSource(Element element) {
    final visitor = ModelVisitor();
    element.visitChildren(visitor);

    var field = '';
    for (var parName in visitor.metaData.keys) {
      String meta = visitor.metaData[parName][0].toString();
      if (meta.contains('@Ruas')) {
        field = parName;
      }
      break;
    }

    var classBuffer = StringBuffer();
    classBuffer.writeln('extension ${visitor.className}BujurSangkar on BangunRuang {');
    classBuffer.writeln('num result() {');
    classBuffer.writeln(' return ${field} * 4;');
    classBuffer.writeln('}');
    classBuffer.writeln('}');

    return classBuffer.toString();
  }
}